import jp.jig.jiglet.*;

public class Desktop extends Jiglet {
	String[] urlList;
	String[] nameList;
	int topCursor;
	
	Image conciergeImage;
	int menuCursor;
	
	String[] MENU_STRING = new String[] {
		"ACRǉ",
		"ACR폜",
		"^CgҏW",
		"",
		"",
		"I",
	};
	
	boolean conciergeFlag = false;
	public void main() {
		conciergeImage = getConciergeImage();
		
		readItemList();
		clearKey();
		setSoftLabel("@\");
		topCursor = 0;
		menuCursor = -1;
		
		if (getLaunchType() == LAUNCHED_AS_CONCIERGE) {
			MENU_STRING[5] = "ҎɈڍs";
			conciergeFlag = true;
		}
		
		for (;;) {
			setTime(currentTime());
			
			repaint();
			sleep(100);
			
			if (getState(STATE_JIGLET) >= JIGLET_DEACTIVE) {
println("A");
				conciergeProcess();
				clearKey();
			}
			
			int key = getKey();
			
			if (key == KEY_UP) {
				topCursor--;
			}
			if (key == KEY_DOWN) {
				topCursor++;
			}
			if (key == KEY_RIGHT) {
				topCursor += 8;
			}
			if (key == KEY_LEFT) {
				topCursor -= 8;
			}
			if (topCursor >= urlList.length) {
				topCursor = urlList.length - 1;
			}
			if (topCursor < 0) {
				topCursor = 0;
			}
			if (key == KEY_SELECT) {
				if (urlList.length == 0) {
					if (showDialog("ACRǉ܂H", 0) == 0) {
						selectItem();
					}
				} else if (topCursor < urlList.length) {
					launch(urlList[topCursor], 0, 0);
				}
			}
			if (key == KEY_SOFT) {
				menuCursor = 0;
				setSoftLabel("BACK");
				for (;;) {
					repaint();
					sleep(50);
					key = getKey();
					if (key == KEY_SELECT) {
						switch (menuCursor) {
							case 0: {
								//ACRǉ
								selectItem();
								break;
							}
							case 1: {
								//ACR폜
								deleteItem(topCursor);
								topCursor = 0;
								break;
							}
							case 2: {
								//OύX
								String str = inputText(nameList[topCursor], TEXT_KANA);
								if (str != null && str.length() > 0) {
									nameList[topCursor] = str;
									writeItemList();
								}
								break;
							}
							case 3: {
								//
								if (urlList.length >= 2 && topCursor > 0) {
									String dum = urlList[topCursor];
									urlList[topCursor] = urlList[topCursor - 1];
									urlList[topCursor - 1] = dum;
									
									dum = nameList[topCursor];
									nameList[topCursor] = nameList[topCursor - 1];
									nameList[topCursor - 1] = dum;
									writeItemList();
									topCursor--;
								}
								break;
							}
							case 4: {
								//
								if (urlList.length >= 2 && topCursor < urlList.length - 1) {
									String dum = urlList[topCursor];
									urlList[topCursor] = urlList[topCursor + 1];
									urlList[topCursor + 1] = dum;
									
									dum = nameList[topCursor];
									nameList[topCursor] = nameList[topCursor + 1];
									nameList[topCursor + 1] = dum;
									writeItemList();
									topCursor++;
								}
								break;
							}
							case 5: {
								//I
								if (!conciergeFlag) {
									terminate();
								}
println("B");
								conciergeProcess();
								break;
							}
						}
						break;
					}
					if (key == KEY_UP) {
						menuCursor = (menuCursor + MENU_STRING.length - 1) % MENU_STRING.length;
					}
					if (key == KEY_DOWN) {
						menuCursor = (menuCursor + 1) % MENU_STRING.length;
					}
					if (key == KEY_IAPP || key == KEY_SOFT) {
						break;
					}
				}
				setSoftLabel("@\");
				key = -1;
				clearKey();
				menuCursor = -1;
			}
			if (key == KEY_IAPP) {
				if (!conciergeFlag) {
					terminate();
				}
println("C");
				conciergeProcess();
			}
			if (conciergeFlag && getState(STATE_SHOULD_SLEEP) == SHOULD_SLEEP_YES) {
println("D");
				conciergeProcess();
			}
		}
	}
	void conciergeProcess() {
		setState(STATE_JIGLET, JIGLET_DEACTIVE);
		repaint();
		sleep(200);
		setState(STATE_JIGLET, JIGLET_SLEEP);
		clearKey();
	}
	
	void selectItem() {
		String url = selectURL();
		if (url != null) {
			//URL`FbN
			boolean add = true;
			for (int i = 0; i < urlList.length; i++) {
				if (urlList[i].equals(url)) {
					add = false;
					break;
				}
			}
			if (add) {
				String name = getNameFromURL(url);
				if (name == null) {
					name = url;
				}
				addItem(name, url);
			} else {
				showDialog("łɒǉĂ܂B", -1);
			}
		}
	}
	void addItem(String title, String url) {
		String[] dum = urlList;
		urlList = new String[dum.length + 1];
		arraycopy(dum, 0, urlList, 0, dum.length);
		urlList[dum.length] = url;
		
		dum = nameList;
		nameList = new String[dum.length + 1];
		arraycopy(dum, 0, nameList, 0, dum.length);
		nameList[dum.length] = title;
		
		writeItemList();
	}
	
	void deleteItem(int idx) {
		if (idx >= 0 && idx < urlList.length) {
			String[] dumU = urlList;
			String[] dumN = nameList;
			urlList = new String[dumU.length - 1];
			nameList = new String[dumU.length - 1];
			int n = 0;
			for (int i = 0; i < dumU.length; i++) {
				if (i != idx) {
					urlList[n] = dumU[i];
					nameList[n] = dumN[i];
					n++;
				}
			}
			writeItemList();
		}
	}
	
	void readItemList() {
		byte[] b = readSP(0, 5120);
		int p = 0;
		int n = (b[p++] & 0xFF);
		urlList = new String[n];
		nameList = new String[n];
		
		for (int i = 0; i < n; i++) {
			int len = ((b[p++] & 0xFF) << 8) | (b[p++] & 0xFF);
			urlList[i] = new String(b, p, len);
			p += len;
			len = ((b[p++] & 0xFF) << 8) | (b[p++] & 0xFF);
			nameList[i] = new String(b, p, len);
			p += len;
		}
	}
	
	void writeItemList() {
		byte[] sp = new byte[10240];
		int p = 0;
		sp[p++] = (byte)(urlList.length);
		
		for (int i = 0; i < urlList.length; i++) {
			byte[] str = urlList[i].getBytes();
			sp[p++] = (byte)(str.length >> 8);
			sp[p++] = (byte)(str.length);
			arraycopy(str, 0, sp, p, str.length);
			p += str.length;
			
			str = nameList[i].getBytes();
			sp[p++] = (byte)(str.length >> 8);
			sp[p++] = (byte)(str.length);
			arraycopy(str, 0, sp, p, str.length);
			p += str.length;
		}
		
		if (p >= 5120) {
			readItemList();
			showDialog("eʃI[o[łB̃ACR폜ĂB", -1);
			return;
		}
		byte[] sp2 = new byte[5120];
		arraycopy(sp, 0, sp2, 0, 5120);
		writeSP(0, sp2);
	}
	
	public void paint(boolean allDrawFlag) {
		setFont(0);
		int fh = getFontHeight();
		int btmY = DH - (fh + 2) * 3 - 6;
		
		setColor(0);
		fillRect(0, 0, DW, DH);
		
		if (conciergeImage != null) {
			drawImage(conciergeImage, (DW - conciergeImage.getWidth()) / 2, (DH - conciergeImage.getHeight()) / 2);
		}
		
		if (getState(STATE_JIGLET) < JIGLET_DEACTIVE) {
			if (menuCursor >= 0) {
				int w = fh * 6 + 6;
				int h = (fh + 2) * MENU_STRING.length + 6;
				int x = (DW - w) / 2;
				int y = (DH - h) / 2;
				
				draw3DButton(x, y, w, h);
				x += 3;
				y += 3;
				w -= 6;
				for (int i = 0; i < MENU_STRING.length; i++) {
					setColor(0, 0, 0);
					if (i == menuCursor) {
						setColor(0, 0, 255);
						fillRect(x - 1, y, w + 2, fh + 2);
						setColor(255, 255, 255);
					}
					drawString(MENU_STRING[i], x, y + fh);
					y += fh + 2;
				}
			}
			if (urlList != null && urlList.length > 0) {
				int x = 5;
				int y = 5;
				for (int i = 0; i < urlList.length; i++) {
					setColor(0xFFFFFF);
					fillRect(x, y, fh, fh);
					
					drawImage(getIconImageFromURL(urlList[i]), x, y);
					if (topCursor == i) {
						setColor(255, 0, 0);
						drawRect(x, y, fh, fh);
						drawRect(x - 1, y - 1, fh, fh);
					}
					y += fh * 3 / 2;
					if (i % 8 == 7) {
						x += fh * 3 / 2;
						y = 5;
					}
				}
				
				int w = DW - fh * 2;
				x = fh;
				y = btmY + 3;
				int h = (fh + 2) * 2 + 6;
				setColor(255, 255, 220);
				fillRect(x, y, w, h);
				setColor(150, 150, 80);
				drawRect(x, y, w, h);
				w -= 6;
				y += 3;
				if (topCursor < nameList.length) {
					setColor(0, 0, 0);
					String str = nameList[topCursor];
					int idx = 0;
					while (idx < str.length()) {
						int idx2 = getLineBreak(str, idx, str.length() - idx, w);
						drawString(str.substring(idx, idx2), x + 3, y + fh);
						y += fh + 2;
						idx = idx2;
					}
				}
			} else {
				setColor(255, 255, 255);
				drawString("L[", 5, fh + 2);
				drawString("ACRǉĂ", 5, fh * 2 + 4);
			}
		}
	}
}
