import jp.jig.jiglet.*;

public class ChangeColor extends Jiglet {
	private static final int STATE_SELECT_ITEM = 1;		//ڑI
	private static final int STATE_SELECT_COLOR = 2;	//FI
	private static final int STATE_EDIT_PALETTE = 3;	//pbgҏW
	private static final int STATE_SELECT_PALETTE = 4;	//ftHgpbgI
	private static final int STATE_SELECT_PATTERN = 5;		//Fp^[I
	
	int[] editPalette = new int[SYSTEM_COLOR_NUM * 3];
	int itemCursor = 0;
	int colorCursor = 0;
	int editCursor;
	int paletteCursor;
	int state = 0;
	int patternCursor;
	
	int[] palette = new int[3];
	
	
	String[] categoryStr = new String[] {
		"j[1",
		"j[2/^XN",
		"",
		"Xe[^X",
		"XN[o[",
	};
	int[][] colorList = new int[][] {
		{
			SYSTEM_COLOR_MENU_FONT1,	SYSTEM_COLOR_MENU_FONT2,		SYSTEM_COLOR_MENU_CURSOR,
			SYSTEM_COLOR_MENU_BG,	SYSTEM_COLOR_MENU_FRAME1,	SYSTEM_COLOR_MENU_FRAME2,	SYSTEM_COLOR_MENU_LIGHT_CURSOR,
		},
		{
			SYSTEM_COLOR_BUTTON_FONT1,	SYSTEM_COLOR_BUTTON_FONT2,		SYSTEM_COLOR_BUTTON_CURSOR,
			SYSTEM_COLOR_BUTTON_BG,		SYSTEM_COLOR_BUTTON_FRAME1,		SYSTEM_COLOR_MENU_FRAME2,
		},
		{
			SYSTEM_COLOR_DESCRIPTION_FONT,	SYSTEM_COLOR_DESCRIPTION_BG,	SYSTEM_COLOR_DESCRIPTION_FRAME,
		},
		{
			SYSTEM_COLOR_STATUS_FONT,		SYSTEM_COLOR_STATUS_BG1,		SYSTEM_COLOR_STATUS_BG2,
		},
		{
			SYSTEM_COLOR_SCROLL_BG,		SYSTEM_COLOR_SCROLL_BAR,
		},
	};
	String[][] colorStr = new String[][] {
		{
			"F",	"]F",	"J[\F",
			"wiF",	"gF",			"ØgF",		"J[\F2",
		},
		{
			"F",	"]F",	"J[\F",
			"wiF",	"gF",			"ØgF",
		},
		{
			"F",	"wiF",		"gF",
		},
		{
			"F",	"wiF1",		"wiF2",
		},
		{
			"wiF",	"o[",
		},
	};
	
	int[] paletteList = new int[] {
		243,54,153,		249,155,204,	200,108,179,	140,23,136,		16,16,119,
		217,0,0,		250,103,107,	127,207,226,	1,152,194,		80,148,148,	
		127,30,2,		255,127,0,		255,230,0,		153,207,22,		64,157,39,
		213,180,56,		255,255,153,	188,157,112,	252,180,130,	204,234,162,
		0,0,0,			102,102,102,	179,179,179,	255,255,255,	172,208,217,
	};
	
	String[] patternName = new String[] {
		"O[",
		"u[",
		"sN",
		"O[",
		"ubN",
		"IW",
		"uE",
		"͂Ȃ",
		"NX}X",
		"POP",
		"N[",
		"_[N",
		"^u[",
		"A[oO[",
		"t[Y",
	};
	
	//C---------------------------------------
	public void main() {
		//ݐݒ肳ĂF擾
		for (int i = 0; i < SYSTEM_COLOR_NUM; i++) {
			int col = getSystemColor(i);
			editPalette[i * 3] = (col & 0xFF0000) >> 16;	//R
			editPalette[i * 3 + 1] = (col & 0xFF00) >> 8;	//G
			editPalette[i * 3 + 2] = (col & 0xFF);			//B
		}
		itemCursor = 0;
		colorCursor = 0;
		clearKey();
		int key = 0;
		int lastKey = 0;
		state = STATE_SELECT_ITEM;
		
		setMenu(new String[] { "WFI" }, new String[] { "jiguEUVer5̔zFݒɂFI܂" });
		
		setTitle("zFݒ");
		setSoftLabel("ۑ");
		
		boolean firstFlag = true;
		
		for (;;) {
			if (key >= 0) {
				repaint();
			}
			key = getKey();
			sleep(20);
			
			if (getKeypadState() == 0) {
				lastKey = -1;
			}
			
			if (key > KEY_LAST) {
				state = STATE_SELECT_PATTERN;
				patternCursor = 0;
			} else {
				if (state == STATE_SELECT_ITEM) {
					if (key == KEY_UP) {
						if (itemCursor > 0) {
							itemCursor--;
						} else {
							itemCursor = categoryStr.length - 1;
						}
					} else if (key == KEY_DOWN) {
						if (itemCursor < categoryStr.length - 1) {
							itemCursor++;
						} else {
							itemCursor = 0;
						}
					} else if (key == KEY_RIGHT || key == KEY_SELECT) {
						setSoftLabel("߂");
						state = STATE_SELECT_COLOR;
						colorCursor = 0;
					} else if (key == KEY_SOFT) {
						int[] array = new int[SYSTEM_COLOR_NUM];
						for (int i = 0; i < SYSTEM_COLOR_NUM; i++) {
							int k = i * 3;
							array[i] = (editPalette[k] << 16) | (editPalette[k + 1] << 8) | editPalette[k + 2];
						}
						setSystemColors(array);
						showDialog("ۑ܂", -1);
//						terminate();
					} else if (key == KEY_IAPP) {
						if (showDialog("ҏWF͕ۑ܂B낵łH", 1) == 0) {
							terminate();
						}
					}
				} else if (state == STATE_SELECT_COLOR) {
					if (key == KEY_UP) {
						if (colorCursor > 0) {
							colorCursor--;
						} else {
							colorCursor = colorList[itemCursor].length - 1;
						}
					} else if (key == KEY_DOWN) {
						if (colorCursor < colorList[itemCursor].length - 1) {
							colorCursor++;
						} else {
							colorCursor = 0;
						}
					} else if (key == KEY_LEFT || key == KEY_IAPP || key == KEY_SOFT) {
						state = STATE_SELECT_ITEM;
						setSoftLabel("ۑ");
					} else if (key == KEY_SELECT) {
						firstFlag = true;
						state = STATE_EDIT_PALETTE;
						editCursor = 0;
						int k = colorList[itemCursor][colorCursor] * 3;
						palette[0] = editPalette[k];
						palette[1] = editPalette[k + 1];
						palette[2] = editPalette[k + 2];
					}
				} else if (state == STATE_EDIT_PALETTE) {
					if (key == KEY_UP) {
						firstFlag = true;
						if (editCursor > 0) {
							editCursor--;
						}
					} else if (key == KEY_DOWN) {
						firstFlag = true;
						if (editCursor < 4) {
							editCursor++;
						}
					} else if (key == KEY_SOFT || key == KEY_IAPP) {
						state = STATE_SELECT_COLOR;
					} else if (key == KEY_SELECT) {
						if (editCursor == 3) {
							state = STATE_SELECT_PALETTE;
							paletteCursor = 0;
						} else {
							int k = colorList[itemCursor][colorCursor] * 3;
							editPalette[k] = palette[0];
							editPalette[k + 1] = palette[1];
							editPalette[k + 2] = palette[2];
							state = STATE_SELECT_COLOR;
						}
					} else if (key == KEY_LEFT) {
						firstFlag = true;
						if (editCursor <= 2) {
							palette[editCursor]--;
							if (lastKey == key) {
								palette[editCursor] -= 4;
							}
							if (palette[editCursor] < 0) {
								palette[editCursor] = 0;
							}
						}
					} else if (key == KEY_RIGHT) {
						firstFlag = true;
						if (editCursor <= 2) {
							palette[editCursor]++;
							if (lastKey == key) {
								palette[editCursor] += 4;
							}
							if (palette[editCursor] > 255) {
								palette[editCursor] = 255;
							}
						}
					} else if (key >= KEY_0 && key <= KEY_9 && editCursor < 3) {
						if (firstFlag) {
							palette[editCursor] = 0;
							firstFlag = false;
						}
						palette[editCursor] = palette[editCursor] * 10 + (key - KEY_0);
						if (palette[editCursor] > 255) {
							palette[editCursor] = 255;
							firstFlag = true;
						}
					}
				} else if (state == STATE_SELECT_PALETTE) {
					if (key == KEY_LEFT) {
						paletteCursor--;
						if (paletteCursor < 0) {
							paletteCursor = 24;
						}
					} else if (key == KEY_RIGHT) {
						paletteCursor++;
						if (paletteCursor >= 25) {
							paletteCursor = 0;
						}
					} else if (key == KEY_UP) {
						paletteCursor -= 5;
						if (paletteCursor < 0) {
							if (paletteCursor == -5) {
								paletteCursor = 24;
							} else {
								paletteCursor += 24;
							}
						}
					} else if (key == KEY_DOWN) {
						paletteCursor += 5;
						if (paletteCursor >= 25) {
							if (paletteCursor == 29) {
								paletteCursor = 0;
							} else {
								paletteCursor -= 24;
							}
						}
					} else if (key == KEY_SELECT) {
						palette[0] = paletteList[paletteCursor * 3];
						palette[1] = paletteList[paletteCursor * 3 + 1];
						palette[2] = paletteList[paletteCursor * 3 + 2];
						state = STATE_EDIT_PALETTE;
						firstFlag = true;
					} else if (key == KEY_IAPP || key == KEY_SOFT) {
						state = STATE_EDIT_PALETTE;
						firstFlag = true;
					}
				} else if (state == STATE_SELECT_PATTERN) {
					if (key == KEY_UP) {
						patternCursor = (patternCursor - 1 + patternName.length) % patternName.length;
					}
					if (key == KEY_DOWN) {
						patternCursor = (patternCursor + 1) % patternName.length;
					}
					if (key == KEY_IAPP || key == KEY_SOFT) {
						state = STATE_SELECT_ITEM;
						setSoftLabel("ۑ");
					}
					if (key == KEY_SELECT) {
						arraycopy(PATTERN_LIST[patternCursor], 0, editPalette, 0, editPalette.length);
						state = STATE_SELECT_ITEM;
						setSoftLabel("ۑ");
					}
				}
				if (key >= 0) {
					lastKey = key;
				}
			}
		}
	}
	
	//`--------------------------------------------
	public void paint(boolean allDrawFlag) {
		if (state == 0) {
			return;
		}
		setFont(0);
		//㕔g̕`
		int fh = getFontHeight();
		if (state <= STATE_SELECT_COLOR) {
			setColor(255, 255, 255);
			fillRect(0, 0, DW, DH);
			
			int by = 14;
			int bh = fh * 11 - 10;
			setColor(0, 0, 0);
			drawString("݂̐ݒ", 5, fh + 1);
			drawRect(3, by, DW - 6, bh);
			drawRect(5, by + 2, DW - 10, bh - 4);
			int bx = 6;
			int bw = DW - 12;
			by += 3;
			{
				//^u̕`
				int tx = bx;
				int ty = by;
				int tw = fh * 7;
				int th = fh + 6;
				draw3DButton2(tx, ty, bw, th);
				for (int i = 0; i < 3; i++) {
					setEditPalette(SYSTEM_COLOR_BUTTON_FRAME1);
					drawLine(tx, by, tx, ty + th);
					drawLine(tx, by, tx + tw - 2, by);
					setEditPalette(SYSTEM_COLOR_BUTTON_FRAME2);
					drawLine(tx + tw - 1, by + 1, tx + tw - 1, by + 1);
					drawLine(tx + tw, by + 2, tx + tw, ty + th);
					
					if (i == 0) {
						setEditPalette(SYSTEM_COLOR_BUTTON_CURSOR);
						fillRect(tx + 1, by + 2, tw - 2, th - 1);
						setEditPalette(SYSTEM_COLOR_BUTTON_FONT2);
						drawString("^XN1", tx + 2, ty + th - 2);
					} else {
						setEditPalette(SYSTEM_COLOR_BUTTON_FONT1);
						drawString("^XN" + (i + 1), tx + 2, ty + th - 2);
					}
					tx += tw + 1;
					tw = fh * 5;
				}
			}
			{
				//j[P`
				int mx = bx + 4;
				int my = by + fh + 6;
				int mw = fh * 5 + 6;
				int mh = (fh + 2) * 3 + 6;
				draw3DRect2(mx, my, mw, mh);
				draw3DRect2(mx + mw, my, mw, mh);
				for (int c = 0; c < 2; c++) {
					int y = my + 3;
					for (int i = 0; i < 3; i++) {
						if (i == 1) {
							if (c == 0) {
								setEditPalette(SYSTEM_COLOR_MENU_LIGHT_CURSOR);
							} else {
								setEditPalette(SYSTEM_COLOR_MENU_CURSOR);
							}
							fillRect(mx + 3, y, mw - 6, fh + 2);
							setEditPalette(SYSTEM_COLOR_MENU_FONT2);
							drawString("j[1", mx + 3, y + fh);
						} else {
							setEditPalette(SYSTEM_COLOR_MENU_FONT1);
							drawString("j[1", mx + 3, y + fh);
						}
						y += fh + 2;
					}
					mx += mw;
				}
				
				//j[Q`
				my += 6;
				mx += fh;
				draw3DButton2(mx, my, mw, mh);
				int y = my + 3;
				for (int i = 0; i < 3; i++) {
					if (i == 1) {
						setEditPalette(SYSTEM_COLOR_BUTTON_CURSOR);
						fillRect(mx + 3, y, mw - 6, fh + 2);
						setEditPalette(SYSTEM_COLOR_BUTTON_FONT2);
						drawString("j[2", mx + 3, y + fh);
					} else {
						setEditPalette(SYSTEM_COLOR_BUTTON_FONT1);
						drawString("j[2", mx + 3, y + fh);
					}
					y += fh + 2;
				}
			}
			//͕`
			{
				int dy = by + bh - fh * 3 - 10;
				int dw = fh * 8;
				int dx = (DW - dw) / 2;
				setEditPalette(SYSTEM_COLOR_DESCRIPTION_BG);
				fillRect(dx, dy, dw, fh + 6);
				setEditPalette(SYSTEM_COLOR_DESCRIPTION_FRAME);
				drawRect(dx, dy, dw, fh + 6);
				setEditPalette(SYSTEM_COLOR_DESCRIPTION_FONT);
				drawString("", dx + 3, dy + fh + 3);
			}
			//ʉ\
			{
				int dy = by + bh - fh - 10;
				setEditPalette(SYSTEM_COLOR_STATUS_BG1);
				fillRect(bx, dy, bw + 1, fh + 6);
				setEditPalette(SYSTEM_COLOR_STATUS_BG2);
				fillRect(bx, dy, bw * 2 / 4, fh + 6);
				setEditPalette(SYSTEM_COLOR_STATUS_FONT);
				drawString("Xe[^X", bx + 3, dy + fh + 2);
			}
			//XN[o[\
			{
				int sx = bx + bw - 2;
				int sy = by + fh + 6;
				int sh = bh - fh - 10;
				setEditPalette(SYSTEM_COLOR_SCROLL_BG);
				fillRect(sx, sy, 3, sh);
				
				setEditPalette(SYSTEM_COLOR_SCROLL_BAR);
				fillRect(sx, sy + 20, 3, 20);
			}
		//I𕔕\---------------------------------------------------
			int sx = 8;
			int sy = by + bh + fh / 2;
			int sh = DH - sy - 6;
			setColor(0, 0, 0);
			drawRect(3, sy, DW - 6, sh);
			drawRect(5, sy + 2, DW - 10, sh - 4);
			{
				int y = sy + 3;
				for (int i = 0; i < categoryStr.length; i++) {
					if (i == itemCursor) {
						if (state == STATE_SELECT_ITEM) {
							setColor(0, 0, 255);
						} else {
							setColor(180, 180, 180);
						}
						fillRect(sx - 1, y, fh * 8 + 2, fh + 2);
						setColor(255, 255, 255);
						
					} else {
						setColor(0, 0, 0);
					}
					drawString(categoryStr[i], sx, y + fh);
					y += fh + 2;
				}
				y = sy + fh + 3;
				
				setColor(255, 0, 0);
				int lx = 5 + fh * 8 + 5;
				if (state == STATE_SELECT_ITEM) {
					drawRect(5, sy + 2, lx - 5, sh - 4);
				} else {
					drawRect(lx, sy + 2, DW - lx - 5, sh - 4);
				}
				sx = fh * 9 + 5;
				
				if (state == STATE_SELECT_COLOR) {
					setColor(0, 0, 0);
					drawString(colorStr[itemCursor][colorCursor], sx + fh * 3, sy + fh * 4);
				}
				for (int i = 0; i < colorList[itemCursor].length; i++) {
					if (state == STATE_SELECT_COLOR && colorCursor == i) {
						setColor(255, 0, 0);
					} else {
						setColor(0, 0, 0);
					}
					drawRect(sx, y, fh, fh);
					
					int k = colorList[itemCursor][i] * 3;
					setColor(editPalette[k], editPalette[k + 1], editPalette[k + 2]);
					fillRect(sx + 2, y + 2, fh - 3, fh - 3);
					
					y += fh + 4;
					if (i == 3) {
						sx += fh + 4;
						y = sy + fh + 3;
					}
				}
			}
		} else if (state == STATE_EDIT_PALETTE) {
			int w = DW * 8 / 10;
			int h = (fh + 4) * 5 + 20;
			int x = (DW - w) / 2;
			int y = (DH - h) / 2;
			
			setColor(255, 255, 255);
			fillRect(x, y, w, h);
			setColor(0, 0, 0);
			drawRect(x, y, w, h);
			
			x += 8;
			y += 8;
			w -= 16;
			int bx = x + fh * 2;
			int bw = w - fh * 2;
			for (int i = 0; i < 3; i++) {
				int cw = palette[i] * bw / 255;
				if (cw > 0) {
					if (i == 0) {
						setColor(255, 0, 0);
					} else if (i == 1) {
						setColor(0, 255, 0);
					} else if (i == 2) {
						setColor(0, 0, 255);
					}
					fillRect(bx, y, cw, fh);
				}
				
				setColor(0, 0, 0);
				drawRect(bx, y, bw, fh);
				if (i == editCursor) {
					setColor(255, 0, 0);
					drawRect(bx - 2, y - 2, bw + 4, fh + 4);
				}
				String ss = "" + palette[i];
				if (ss.length() == 1)
					ss = "  " + ss;
				else if (ss.length() == 2)
					ss = " " + ss;
				drawString(ss, x, y + fh);
				
				y += fh + 4;
			}
			
			if (editCursor == 3) {
				setColor(255, 0, 0);
			} else {
				setColor(0, 0, 0);
			}
			drawString("pbgI", x, y + fh);
			y += fh + 4;
			
			setColor(220, 220, 220);
			fillRect(x, y, fh * 2 + 6, fh + 6);
			if (editCursor == 4) {
				setColor(255, 0, 0);
			} else {
				setColor(0, 0, 0);
			}
			drawString("", x + 3, y + 2 + fh);
			
			setColor(palette[0], palette[1], palette[2]);
			fillRect(x + (fh * 2 + 6) + 8, y, w - (fh * 2 + 6) - 8, fh + 6);
			setColor(0, 0, 0);
			drawRect(x + (fh * 2 + 6) + 8, y, w - (fh * 2 + 6) - 8, fh + 6);
		} else if (state == STATE_SELECT_PALETTE) {
			int rs = fh + 6;
			int s = rs * 5 + 6;
			int x = (DW - s) / 2;
			int y = (DH - s) / 2;
			
			setColor(255, 255, 255);
			fillRect(x - 10, y - 10, s + 20, s+ 20);
			setColor(0, 0, 0);
			drawRect(x, y, s, s);
			
			x += 3;
			y += 3;
			
			for (int k = 0; k < 5; k++) {
				int ry = y + k * rs;
				for (int i = 0; i < 5; i++) {
					int rx = x + i * rs;
					int idx = (k * 5 + i);
					
					if (paletteCursor == idx) {
						setColor(255, 0, 0);
						drawRect(rx + 1, ry + 1, rs - 3, rs - 3);
						drawRect(rx, ry, rs - 1, rs - 1);
					}
					idx *= 3;
					setColor(paletteList[idx], paletteList[idx + 1], paletteList[idx + 2]);
					fillRect(rx + 4, ry + 4, rs - 7, rs - 7);
					setColor(0, 0, 0);
					drawRect(rx + 3, ry + 3, rs - 7, rs - 7);
				}
			}
		} else if (state == STATE_SELECT_PATTERN) {
			int w = fh * 8 + 8;
			int h = (fh + 2) * patternName.length + 8;
			int x = (DW - w) / 2;
			int y = (DW - h) / 2;
			
			setColor(0xFFFFFF);
			fillRect(x, y, w, h);
			setColor(0);
			drawRect(x, y, w, h);
			drawRect(x + 2, y + 2, w - 4, h - 4);
			
			x += 4;
			y += 4;
			w -= 8;
			
			for (int i = 0; i < patternName.length; i++) {
				if (i == patternCursor) {
					setColor(0x0000FF);
					fillRect(x, y, w, fh + 1);
					setColor(0xFFFFFF);
				} else {
					setColor(0);
				}
				drawString(patternName[i], x + 1, y + fh);
				y += fh + 2;
			}
		}
	}
	//ݕύX̐FidxԖڂݒ肷
	void setEditPalette(int idx) {
		idx *= 3;
		setColor(editPalette[idx], editPalette[idx + 1], editPalette[idx + 2]);
	}
	//ݕύX̐FButton
	void draw3DButton2(int x, int y, int w, int h) {
		setEditPalette(SYSTEM_COLOR_BUTTON_BG);
		fillRect(x, y, w, h);
		setEditPalette(SYSTEM_COLOR_BUTTON_FRAME1);
		drawLine(x, y, x + w, y);
		drawLine(x, y, x, y + h);
		setEditPalette(SYSTEM_COLOR_BUTTON_FRAME2);
		drawLine(x + w, y, x + w, y + h);
		drawLine(x, y + h, x + w, y + h);
	}
	//ݕύX̐FRect
	void draw3DRect2(int x, int y, int w, int h) {
		setEditPalette(SYSTEM_COLOR_MENU_BG);
		fillRect(x, y, w, h);
		setEditPalette(SYSTEM_COLOR_MENU_FRAME1);
		drawLine(x, y, x + w, y);
		drawLine(x, y, x, y + h);
		setEditPalette(SYSTEM_COLOR_MENU_FRAME2);
		drawLine(x + w, y, x + w, y + h);
		drawLine(x, y + h, x + w, y + h);
	}
	
	//Fp^[
	static final int[][] PATTERN_LIST = new int[][] {
		{
			//O[
			//drawButto֌W
			0, 0, 0,		255, 255, 255,	0, 0, 255, 
			210, 210, 210,	240, 240, 240,	150, 150, 150,
			//F̃tHg
			120, 120, 120,
			//drawRect֌W
			0, 0, 0,		255, 255, 255,	0, 0, 255,
			255, 255, 255,	150, 150, 150,	240, 240, 240,
			//F̃J[\
			130, 130, 130,
			//ʉbZ[Wp
			0, 0, 255,		0, 0, 180,		255, 255, 255,
			//XN[o[
			0, 0, 0,		220, 220, 220,
			//ʉ
			0, 0, 0,		255, 255, 220,	0, 0, 0,
		},
		{
			//u[
			//drawButton֌W
			0, 0, 0,		255, 255, 255,	0, 0, 255,
			180, 180, 250,	230, 230, 255,	0, 0, 170,
			//tHg
			0, 0, 150,
			//drawRect֌W
			0, 0, 0,		255, 255, 255,	0, 0, 255,
			255, 255, 255,	0, 0, 170,		230, 230, 255,
			//F̃J[\
			130, 130, 255,
			//ʉbZ[Wp
			0, 0, 255,		0, 0, 180,		255, 255, 255,
			//XN[o[
			0, 0, 0,		150, 150, 255,
			//ʉ
			0, 0, 180,		180, 180, 255,	0, 0, 0,
		},
		{
			//sN
			//drawButtonp
			0, 0, 0,		0, 0, 0,		255, 255, 255,
			255, 220, 220,	255, 230, 230,	220, 140, 140,
			//F̃tHgBI^up
			160, 120, 120,
			//j[p,draw3DRectp
			0, 0, 0,		0, 0, 0,		255, 255, 255,
			255, 220, 220,	255, 230, 230,	220, 140, 140,
			//J[\
			220, 220, 220,
			//ʉbZ[Wp
			220, 170, 170,	255, 220, 220,	0, 0, 0,
			//XN[o[
			0, 0, 0,		200, 100, 100,
			//ʉ
			0, 0, 0,		255, 230, 230,		255, 255, 255,
		},
		{
			//O[
			//drawButton֌W
			0,  0, 0,		255, 255, 255,	0, 150, 0,
			150, 220, 150,	230, 255, 230,	80, 200, 80,
			//F̃tHgBI^up
			120, 200, 120,
			//j[p,draw3DRectp
			0,  0, 0,		255, 255, 255,	0, 150, 0,
			255, 255, 255,	80, 200, 80,	230, 255, 230,
			
			130, 130, 130,
			//ʉbZ[Wp
			0, 180, 0,		120, 200, 120,	0, 0, 0,
			//XN[o[
			0, 0, 0,		0, 220, 0,
			//ʉ
			0, 0, 0,		220, 255, 220,	0, 0, 0,
		},
		{
			//ubN
			//^uAdraw3DButtonp
			255, 255, 255,	255, 255, 255,	17, 53, 200,
			0, 0, 0,		255, 255, 255,	255, 255, 255,
			//F̃tHgBI^up
			160, 160, 160,
			//j[p,draw3DRectp
			255, 255, 255,	255, 255, 255,	17, 53, 200,
			0, 0, 0,		255, 255, 255,	255, 255, 255,
			//J[\
			7, 20, 160,
			//ʉbZ[Wp
			17, 53, 200,	17, 53, 115,	255, 255, 255,
			//XN[o[
			0, 0, 9,		21, 118, 205,
			//ʉ
			255, 255, 255,	5, 20, 115,		0, 0, 0,
		},
		{
			//IW
			//^uAdraw3DButtonp
			255, 255, 255,	0, 0, 0,		255, 230, 150,
			255, 160, 50,	255, 255, 200,	230, 130, 30,
			//F̃tHgBI^up
			170, 150, 70,
			//j[p,draw3DRectp
			255, 255, 255,	0, 0, 0,		255, 230, 150,
			255, 160, 50,	230, 130, 30,	255, 255, 200,
			//J[\
			255, 200, 100,
			//ʉbZ[Wp
			230, 130, 30,	255, 230, 150,	0, 0, 0,
			//XN[o[
			0, 0, 0,		255, 150, 50,
			//ʉ
			0, 0, 0,		255, 230, 150,	0, 0, 0,
		},
		{
			//uE
			//^uAdraw3DButtonp
			255,255,175,	85,37,16,	157,175,72,
			93,44,10,		172,134,60,	50,24,0,
			//F̃tHgBI^up
			200, 170, 120,
			//j[p,draw3DRectp
			255,255,175,	85,37,16,	157,175,72,
			93,44,10,		50,24,0,	172,134,60,
			//J[\
			120, 100, 40,
			//ʉbZ[Wp
			0, 0, 0,		93,44,10,	157,175,72,
			//XN[o[
			0, 0, 0,		255, 129, 10,
			//ʉ
			255, 255, 175,	150, 100, 60,	0, 0, 0,
		},
		{
			//͂Ȃ
			//^uAdraw3DButtonp
			255, 255, 255,	121, 99, 81,	226, 190, 158,
			124, 112, 102,	225, 207, 219,	185, 149, 197,
			//F̃tHgBI^up
			200, 190, 170,
			//j[p,draw3DRectp
			255, 255, 255,	121, 99, 81,	226, 190, 158,
			124, 112, 102,	225, 207, 219,	185, 149, 197,
			//J[\
			200, 180, 170,
			//ʉbZ[Wp
			180, 160, 130,	226, 190, 158,	121, 99, 81,
			//XN[o[
			0, 0, 0,	196, 91, 99,
			//ʉ
			255, 255, 255,	185, 149, 197,	225, 207, 219,
		},
		{
			//NX}X
			//^uAdraw3DButtonp
			255, 255, 255,	255, 255, 255,	206, 16, 14,
			22,68,16,		241,217,81,		141,103,22,
			//F̃tHgBI^up
			160, 180, 160,
			//j[p,draw3DRectp
			255, 255, 255,	255, 255, 255,	206, 16, 14,
			22,68,16,		241,217,81,		141,103,22,
			//J[\
			150, 0, 0,
			//ʉbZ[Wp
			80,150,80,		22,68,16,		255, 255, 255,
			//XN[o[
			0, 0, 0,		255, 255, 0,
			//ʉ
			255, 255, 255,	22,68,16,		241,217,81,
		},
		{
			//POP
			//^uAdraw3DButtonp
			255, 255, 255,		255, 255, 0,	255, 0, 78,
			0, 142, 255,		0, 0, 0,		0, 0, 0,
			//F̃tHgBI^up
			50, 100, 150,
			//j[p,draw3DRectp
			255, 255, 255,		255, 255, 0,	255, 0, 78,
			0, 142, 255,		0, 0, 0,		0, 0, 0,
			//J[\
			200, 0, 30,
			//ʉbZ[Wp
			0,100,200,		0,142,255,		255,0,78,
			//XN[o[
			0, 0, 0,		255, 255, 0,
			//ʉ
			255, 255, 255,	0, 142, 255,	0, 0, 0,
		},
		{
			//N[
			//^uAdraw3DButtonp
			73,75,75,		21,23,22,		115,176,248,
			232,232,233,	36,32,32,		40,40,42,
			//F̃tHgBI^up
			73,75,75,
			//j[p,draw3DRectp
			73,75,75,		21,23,22,		115,176,248,
			232,232,233,	40,40,42,		36,32,32,
			//J[\
			200, 200, 200,
			//ʉbZ[Wp
			70,140,200,		115,176,248,	21,23,22,
			//XN[o[
			0, 0, 0,		75,139,255,
			//ʉ
			21,23,22,		232,232,233,	0, 0, 0,
		},
		{
			//_[N
			//^uAdraw3DButtonp
			255, 255, 255,	255, 255, 255,		33, 33, 33,
			99, 99, 99,		200, 200, 200,		0, 0, 0,
			//F̃tHgBI^up
			200, 200, 200,
			//j[p,draw3DRectp
			255, 255, 255,	255, 255, 255,		33, 33, 33,
			99, 99, 99,		200, 200, 200,		0, 0, 0,
			//J[\
			66, 66, 66,
			//ʉbZ[Wp
			140, 140, 140,	200, 200, 200,		0, 0, 0,
			//XN[o[
			0, 0, 0,		255, 205, 0,
			//ʉ
			255, 255, 255,	99, 99, 99,			255, 205, 0,			//g
		},
		{
			//^u[
			//^uAdraw3DButtonp
			255, 255, 255,		255, 255, 255,		0, 121, 255,
			84, 105, 127,		177, 187, 192,		40, 40, 40,
			//F̃tHgBI^up
			160, 180, 200,
			//j[p,draw3DRectp
			255, 255, 255,		255, 255, 255,		0, 121, 255,
			84, 105, 127,		40, 40, 40,			177, 187, 192,
			//J[\
			40, 110, 200,
			//ʉbZ[Wp
			120, 150, 200,		164, 190, 236,		21, 23, 22,
			//XN[o[
			0, 0, 0,			0, 70, 255,
			//ʉ
			0, 0, 0,			84, 105, 127,		0, 0, 0,
		},
		{
			//A[oO[
			//^uAdraw3DButtonp
			81, 89, 78,		203, 89, 92,		255, 255, 250,
			203, 198, 198,	240, 240, 240,		40, 40, 40,
			//F̃tHgBI^up
			110, 110, 110,
			//j[p,draw3DRectp
			81, 89, 78,		203, 89, 92,	255, 255, 250,
			203, 198, 198,	40, 40, 40,		240, 240, 240,
			//J[\
			230, 230, 230,
			//ʉbZ[Wp
			50, 50, 50,		110, 94, 95,	255, 255, 255,
			//XN[o[
			189, 188, 183,	219, 0, 33,
			//ʉ
			81, 89, 78,		203, 198, 198,	203, 89, 89,
		},
		{
			//t[Y
			//^uAdraw3DButtonp
			123, 123, 142,		17, 177, 230,		255, 255, 255,
			218, 237, 255,		238, 255, 255,		70, 130, 180,
			//F̃tHgBI^up
			200, 200, 210,
			//j[p,draw3DRectp
			123, 123, 142,		17, 177, 230,		255, 255, 255,
			218, 237, 255,		70, 130, 180,		238, 255, 255,
			//J[\
			180, 200, 230,
			//ʉbZ[Wp
			50, 50, 50,			112, 113, 100,		255, 255, 255,
			//XN[o[
			88, 88, 88,			134, 205, 235,
			//ʉ
			123, 123, 142,		218, 237, 255,		70, 130, 180,
		},
		
	};
}
